/*
    Solutie 80 p
    prof. Eugen Nodea
*/
# include <cstdio>
# include <queue>
# include <algorithm>

# define nmax 253
# define mmax 253
# define pmax 10001
# define inf 253*253+2
using namespace std;

int A[nmax][mmax],M[nmax][mmax],Timp[nmax][mmax];
int dx[] = {-1, 0, 1};
int dy[] = { 0, 1, 0};
int n, m, p, d, T, i, j, k, l, c, e, v, r, t, x;

struct cel
{
    int l,c;
};
queue <cel> q;

inline int caut(int l, int c, int x, int ts)
{
    int i, j, t, d;
    //caut existenta centrului unui gheizer unee am memorate date despre durata
    for (i=l-x; i<=l+x; i++)
         for (j=c-x; j<=c+x; j++)
            if (A[i][j] && i>0 && j>0 && i<=n && j<=m)
            {
                //calculez daca este afectata celula (i,j)
                t = A[i][j] / 100;   // timpul intre eruptii

                d = A[i][j] % 100;   // durata unei eruptii
                if (ts % (t + d) >= t) return 0;
            }
    return 1;
}

void Lee(int l, int c)
{
	int ic, jc, iv, jv, k, ts, x, ok;
    cel p,u;

    p.l=l; p.c=c;
	q.push(p);
	Timp[l][c] = 1;

	while (!q.empty())
	{
	    p = q.front(); q.pop();
		ic = p.l; jc = p.c;
		if (Timp[ic][jc] != inf && ic == e && jc == m)
		{
		    break;
		}
		// timpul scurs
        ts = Timp[ic][jc];
		for (k=0; k<3; ++k)
		{
			iv = ic + dx[k];
			jv = jc + dy[k];

			if (iv>0 && iv<=n && jv>0 && jv<=m)
			{
                //determin daca celula este afectata
                x = M[iv][jv];
                ok = 1;
                if (x && caut(iv,jv,x,ts) == 0) ok=0;
                if (Timp[iv][jv] > Timp[ic][jc] + 1 && ok)
                    {
                        Timp[iv][jv] = Timp[ic][jc] + 1;
                        u.l = iv; u.c = jv;
                        q.push(u);
                    }
                else if (Timp[iv][jv]<=Timp[ic][jc] && ok)
                        {
                            Timp[iv][jv] = Timp[ic][jc] + 1;
                            u.l = iv; u.c = jv;
                            q.push(u);
                        }
			}
		}
	}
}

int main()
{
    freopen("gheizere.in", "r", stdin);
    freopen("gheizere.out", "w", stdout);

    scanf("%d %d %d", &n, &m, &p);
    scanf("%d %d", &v, &e);

    for (k=1; k<=p; ++k)
    {
        scanf("%d %d %d %d %d", &i, &j, &r, &t, &d);

        //retin pentru fiecare gheizer atat timpul intre eruptii cat si durata unei eruptii
        A[i][j] = t * 100 + d;

        //retin in matrice M zonele afectate de eruptie (raza maxima)
        for (l=1; l<=2 * r + 1; ++l)
            for (c=1; c<=2 * r + 1; ++c)
                if (l>0 && l<=n && c>0 && c<=m)
                    M[i - r + l - 1][j - r + c - 1] = max(r,M[i - r + l - 1][j - r + c - 1]);
    }

    //initializare
	for (i=1; i<=n; i++)
		for (j=1; j<=m; j++)
			Timp[i][j] = inf;

    Lee(v,1);

    if (Timp[e][m] == inf) printf("0\n"); //nu este cazul
                      else printf("%d\n",Timp[e][m]);

	return 0;
}
