#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;

const char iname[] = "drept.in";
const char oname[] = "drept.out";

const int MAX_N = 10005;
const int MAX_COORD = 10005;

typedef struct {
    int x, y1, y2, sgn;
} edge;

bool edge_cmp(edge a, edge b) {
    if (a.x != b.x)  return a.x < b.x;
    return a.sgn < b.sgn;
}

vector <edge> edges;  int n, ys[MAX_COORD];


int main(void) {
    FILE *fi = fopen(iname, "r");
    assert(fscanf(fi, "%d", &n) == 1);
    assert(1 <= n && n <= 10000);
    for (int i = 0; i < n; ++ i) {
        int x, y, d;
        assert(fscanf(fi, "%d %d %d", &x, &y, &d) == 3);
        assert(0 <= x && x <= 5000);
        assert(0 <= y && y <= 5000);
        assert(1 <= d && d <= 5000);
        edge e;
        e.x = x, e.y1 = y, e.y2 = y + d - 1, e.sgn = +1;
        edges.push_back(e);
        e.x = x + d, e.y1 = y, e.y2 = y + d - 1, e.sgn = -1;
        edges.push_back(e);
    }
    assert((int) edges.size() == n * 2);
    sort(edges.begin(), edges.end(), edge_cmp);

    int min_y = MAX_COORD, max_y = 0, prev_x = 0;
    int area = 0, overlaps = 0;
    for (vector <edge>::iterator it = edges.begin(); it != edges.end(); ++ it) {
        edge e = (*it);
        int count = 0;
        min_y = min(min_y, e.y1);
        max_y = max(max_y, e.y2);
        for (int j = min_y; j <= max_y; ++ j) if (ys[j] > 0) {
            count ++;
        }
        area += count * (e.x - prev_x);

        for (int j = e.y1; j <= e.y2; ++ j)
            ys[j] += e.sgn;            

        for (int j = min_y; j <= max_y; ++ j) if (ys[j] > 0) {
            overlaps = max(overlaps, ys[j]);
        }

        prev_x = e.x;
    }
    fprintf(fopen(oname, "w"), "%d\n%d\n", area, overlaps);

    fclose(fi);
    return 0;
}
