/*
    Solutie 50 p
    backtracking
    stud. Marius Stroe
*/
#include <cstdio>
#include <cassert>
#include <algorithm>
using namespace std;

const char iname[] = "poly.in";
const char oname[] = "poly.out";

const int MAX_N = 1 << 16;
const int Modulo = 30103;


int headers[MAX_N][2], n, answer = 0;


void bkt(int i, int perimeter) {
    if (perimeter == 2 * n + 2) {
        answer ++;
    } else {
        if (i == 0) {
            for (int end = 1; end <= n; ++ end) {
                headers[i][0] = 1, headers[i][1] = end;
                bkt(i + 1, 2 * end + 2);
            }
        } else {
            int low = headers[i - 1][0], high = headers[i - 1][1];
            for (int start = low; start <= high; ++ start) {
                for (int end = high; end <= n; ++ end) {
                    int new_perimeter = perimeter - (high - start + 1) +
                                        (end - high) + (end - start + 1) + 2;
                    if (new_perimeter > 2 * n + 2) {
                        break;
                    }
                    headers[i][0] = start, headers[i][1] = end;
                    bkt(i + 1, new_perimeter);
                }
            }
        }
    }
}

int main(void) {
    FILE *fi = fopen(iname, "r");
    assert(fscanf(fi, "%d", &n) == 1);
    assert(2 <= n && n <= 15000);
    fclose(fi);

    bkt(0, 0);
    fprintf(fopen(oname, "w"), "%d\n", answer % Modulo);

    return 0;
}
